<?php
/***************************************************************************
 *                               memberlist.php
 *                            -------------------
 *   begin                : Friday, 20. April 2007
 *   copyright            : ('C) 2007-2008 Flava Clown
 *   email                : http://flavaclown.de/contact.php
 *
 *   $Id: memberlist.php, v1.02 11/08/2008 19:28 Flava Clown $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPATM', true);
$include_location = dirname($_SERVER['SCRIPT_FILENAME'])."/";
include($include_location.'include/conf.php');
include($include_location.'include/common.'.$phpExt);

// just like the userlist function from the functions.php, but modified for the sort options
function userslist_flava($order = "name")
{
	global $users_folder_name, $user_account_creation_time, $user_status, $activationcode;
	global $user_wish_receive_digest, $user_email, $reserved_files, $direction, $order;

	$direction = ($direction == DIRECTION_UP) ? DIRECTION_DOWN : DIRECTION_UP;

	$userslist = "";
	// Browse each user
	$handle=opendir($users_folder_name);
	while (false !== ($filename = readdir($handle)))
	{
		if (substr($filename,0,1) != '.' && !eregi($reserved_files, $filename))
		{
			if (!is_dir("$users_folder_name/$filename"))
			{
				switch($order)
				{
					case 'estado';
						load_user_profile($filename);
						$userslist[$filename] = $user_status;
						break;
					case 'fecha';
						load_user_profile($filename);
						$userslist[$filename] = $user_account_creation_time;
						break;
					case 'access';
						list($files_uploaded, $files_downloaded, $files_emailed, $last_acess_time) = load_userstat($filename);
						$userslist[$filename] = $last_acess_time;
						break;
					case 'uploaded';
						list($files_uploaded, $files_downloaded, $files_emailed, $last_acess_time) = load_userstat($filename);
						$userslist[$filename] = $files_uploaded;
						break;
					case 'downloaded';
						list($files_uploaded, $files_downloaded, $files_emailed, $last_acess_time) = load_userstat($filename);
						$userslist[$filename] = $files_downloaded;
						break;
					default;
						$userslist[$filename] = $filename;
						break;
				}
			}
		}
	}
	closedir($handle);

	if(is_array($userslist))
	{
		switch($order)
		{
			case 'estado':
				$direction == DIRECTION_UP ? asort($userslist) : arsort($userslist);
				break;
			case 'fecha':
				$direction == DIRECTION_UP ? asort($userslist) : arsort($userslist);
				break;
			case 'access':
				$direction == DIRECTION_UP ? asort($userslist) : arsort($userslist);
				break;
			case 'uploaded':
				$direction == DIRECTION_UP ? asort($userslist) : arsort($userslist);
				break;
			case 'downloaded':
				$direction == DIRECTION_UP ? asort($userslist) : arsort($userslist);
				break;
			default:
				$direction == DIRECTION_DOWN ? arsort($userslist) : asort($userslist);
				break;
		}
	}
	return $userslist;
}

function memberlist()
{
	global $phpExt,$i_am_admin;
	global $mess,$font,$normalfontcolor,$selectedfontcolor,$homeurl,$languages;
	global $uploadcentercaption,$logged_user_name,$mail_functions_enabled;
	global $tablecolor,$bordercolor,$headercolor,$headerfontcolor,$order,$letter,$accpage;
	global $user_wish_receive_digest,$user_email,$user_account_creation_time,$user_status,$activationcode;
	global $accountsperpage,$shownaccounts,$currentaccount,$direction,$datetimeformat;

	$users = userslist_flava($order);
	$usercount = count($users);

	$shownaccounts = 0;
	$currentaccount = -1; // makes sure that we show as much accounts per page as set in the conf.php (0 would show one less)
	while (list($filename, $filed) = each($users))
	{
		$currentaccount++;
		if ($usercount > $accountsperpage)
		{
			if ($order == "name")
			{
				if ($letter != "All")
				{
					$let = ucfirst(substr($filed,0,1));
					if ($letter == '*')
					{
						if (eregi("[A-Z]", $let))
						{ continue; }
					}
					else
					{
						if ($let != $letter)
						{ continue; }
					}
				}
			}
			else
			{
				if ($accpage != 0)
				{
					if ($accpage-1 != (int)($currentaccount/$accountsperpage))
					{ continue; }
				}
			}
		}

		$shownaccounts++;
		load_user_profile($filename);

		$account_date = getdate($user_account_creation_time);
		$month = $account_date['mon'];
		$mday = $account_date['mday'];
		$year = $account_date['year'];
		list($files_uploaded, $files_downloaded, $files_emailed, $last_acess_time) = load_userstat($filename);
		if ($last_acess_time == 0 || $last_acess_time == "")
		{ $last_acess_time = $user_account_creation_time; }
		$access_date = getdate($last_acess_time);
		$accessmonth = $access_date['mon'];
		$accessmday = $access_date['mday'];
		$accessyear = $access_date['year'];

		$accountnumber = $currentaccount + 1; // needed to start with 1 instead of 0
		echo "
<tr bgcolor=\"$tablecolor\">
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">$accountnumber</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">\n";
		if ($i_am_admin)
		{ echo "<a href=\"user.$phpExt?user=$filename&amp;".SID."\" style=\"font-size:10px;\">$filename</a>"; }
		else
		{ echo $filename; }
		echo "</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">";

		if ($user_status == NORMAL)
		{ echo $mess[75]; }
		elseif ($user_status == ADMIN)
		{ echo $mess[77]; }
		elseif ($user_status == POWER)
		{ echo $mess[76]; }
		elseif ($user_status == VIEWER)
		{ echo $mess[138]; }
		elseif ($user_status == UPLOADER)
		{ echo $mess[139]; }

		echo "</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">$mday. $mess[$month] $year</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">$accessmday. $mess[$accessmonth] $accessyear</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">";

		if ($files_uploaded)
		{ echo $files_uploaded; }
		else
		{ echo "0"; }

		echo "</font></td>
<td align=\"center\" valign=\"top\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">";

		if ($files_downloaded)
		{ echo $files_downloaded; }
		else
		{ echo "0"; }

		echo "</font></td>
</tr>";
	}
}

// added by Flava Clown - 22.04.2007
function show_memberlist()
{
	global $phpExt,$i_am_admin;
	global $mess,$font,$normalfontcolor,$selectedfontcolor;
	global $tablecolor,$bordercolor,$headercolor,$headerfontcolor,$order,$letter,$accpage;
	global $user_email,$user_account_creation_time,$user_status;
	global $accountsperpage,$shownaccounts,$currentaccount,$direction;

	if (!isset($order) || $order == "")
	{ $order = "name"; }

	// the shown accounts per page, change this if you want to
	$accountsperpage = 30;

	$users = userslist_flava($order);
	$usercount = count($users);

	// the site navigation, if we have more accounts then $accountsperpage
	if ($usercount > $accountsperpage)
	{
		if (isset($_GET["direction"]) && $_GET["direction"] != "")
		{ $directionf = getGetVar('direction'); }
		else
		{ $directionf = "0"; }
		if (!isset($accpage) || $accpage == "")
		{ $accpage = 1; }
		echo "
<table cellSpacing=\"1\" cellPadding=\"4\" width=\"90%\" bgColor=\"$bordercolor\" border=\"0\" summary=\"layout: the site navigation\">
<tr>
<td align=\"center\" bgColor=\"$tablecolor\">
<table cellSpacing=\"0\" cellPadding=\"0\" width=\"100%\" border=\"0\" summary=\"layout\">
<tr>
<td width=\"20%\" align=\"left\" bgColor=\"$tablecolor\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">";
		if ($order == "name" || $order == "")
		{ echo "<strong>$letter</strong>"; }
		else
		{
			if ($accpage == 0)
			{ echo "<strong>All</strong>"; }
			else
			{ echo "<strong>Page $accpage</strong>"; }
		}
		echo "</font></td>
<td width=\"60%\" align=\"center\" bgColor=\"$tablecolor\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">";

		if ($order == "name")
		{
			echo "<a href=\"memberlist.${phpExt}?order=$order&letter=*&amp;".SID."\">*</a> ";
			for ($i = 65; $i <= 90; $i++)
			{
				$lett = chr($i);
				echo "<a href=\"memberlist.${phpExt}?order=$order&amp;letter=$lett&amp;".SID."\">$lett</a> ";
			}
			echo "<a href=\"memberlist.${phpExt}?order=$order&amp;letter=All&amp;".SID."\">$mess[142]</a>";
		}
		else
		{
			for ($i = 1; $i < $usercount/$accountsperpage + 1; $i++)
			{
				echo "<a href=\"memberlist.${phpExt}?order=$order&amp;direction=$directionf&amp;accpage=$i&amp;".SID."\">$i</a> ";
			}
			echo "<a href=\"memberlist.${phpExt}?order=$order&amp;direction=$directionf&amp;accpage=0&amp;".SID."\">$mess[142]</a>";
		}

		echo "</font></td>
<td width=\"20%\" align=\"right\" bgColor=\"$tablecolor\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">$mess[160] $usercount $mess[161]</font></td>
</tr>
</table>
</td>
</tr>
</table>
<br>";
	}

	// finally: the memberlist table, first the header with the sort options
	echo "
<table border=\"0\" width=\"90%\" bgcolor=\"$bordercolor\" cellpadding=\"4\" cellspacing=\"1\" summary=\"the memberlist table\">
<tr bgcolor=\"$headercolor\">
<td align=\"center\" valign=\"middle\" width=\"30\"><font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>#</b></font></td>
<td align=\"center\" valign=\"middle\" width=\"20%\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[57]</b>
<a href=\"memberlist.${phpExt}?order=name&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; //username
	if ($order == "name" || $order == "")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
<td align=\"center\" valign=\"middle\" width=\"20%\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[156]</b>
<a href=\"memberlist.${phpExt}?order=estado&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; // user status
	if ($order == "estado")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
<td align=\"center\" valign=\"middle\" width=\"20%\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[154]</b>
<a href=\"memberlist.${phpExt}?order=fecha&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; // joined (account creation time)
	if ($order == "fecha")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
<td align=\"center\" valign=\"middle\" width=\"20%\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[155]</b>
<a href=\"memberlist.${phpExt}?order=access&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; // last access
	if ($order == "access")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
<td align=\"center\" valign=\"middle\" width=\"35\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>UL</b>
<a href=\"memberlist.${phpExt}?order=uploaded&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; // uploads
	if ($order == "uploaded")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
<td align=\"center\" valign=\"middle\" width=\"35\" nowrap>
<font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>DL</b>
<a href=\"memberlist.${phpExt}?order=downloaded&amp;direction=$direction&amp;accpage=$accpage&amp;letter=$letter&amp;".SID."\">"; // downloads
	if ($order == "downloaded")
	{ echo "<img src=\"images/fleche${direction}.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	else
	{ echo "<img src=\"images/fleche.gif\" alt=\"$mess[197]\" width=\"10\" height=\"10\" border=\"0\"></a>"; }
	echo "</font></td>
</tr>";
	// now the memberlist - already formated, see above (function memberlist())
	$direction = ($direction == DIRECTION_DOWN) ? DIRECTION_UP : DIRECTION_DOWN;
	memberlist();
	// the row which shows 'Total: # account(s)' and 'Shown # account(s) of #'
	echo "
<tr bgcolor=\"$tablecolor\" valign=\"top\">
<td align=\"right\" colspan=\"7\">
<table cellSpacing=\"0\" cellPadding=\"0\" width=\"100%\" border=\"0\" summary=\"layout\">
<tr>
<td align=\"left\" bgColor=\"$tablecolor\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">$mess[160] $usercount $mess[161]</font></td>
<td align=\"right\" bgColor=\"$tablecolor\"><font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">
";
	echo sprintf($mess[163], $shownaccounts, $usercount);
	echo "</font></td>
</tr>
</table>
</td>
</tr>
</table>
";
}
// end FC

function show_default($message)
{
	global $logged_user_name,$user_status,$mess,$grants,$phpExt;

	// checks if we have the aLy string (ALY01) in the language file, if not we use "Member List".
	if (!isset($mess['ALY01']))
	{ $mess['ALY01'] = "Member List"; }

	if ($logged_user_name != "")
	{
		if (check_is_user_session_active($logged_user_name))
		{
			// If user already entered, show logout screen
			if ($message == "")
			{ $message = $mess['ALY01']; }
			place_message($mess['ALY01'], $message, basename(__FILE__));
			show_memberlist();
			return;
		}
	}
	// Show default window
	if ($message == "")
	{ $message = $mess[42]; }
	place_message($mess[42], $message, basename(__FILE__));
}

//----------------------------------------------------------------------------
//      MAIN
//----------------------------------------------------------------------------

// Se l'utente non  loggato lo indirizzo al login
if ($logged_user_name == '')
{
	header($header_location.'login.'.$phpExt.'?'.SID);
	exit;
}

// In caso non sia abilitata la visione anonima, reindirizzo a index.php
if (!$grants[$user_status][VIEW])
{
	header($header_location.'index.'.$phpExt.'?'.SID);
	exit;
}

if ($user_status == ADMIN)
{ $i_am_admin = true; }
else
{ $i_am_admin = false; }

switch($action)
{
	case ACTION_SELECTSKIN;
		change_skin();
		show_default($mess[96]);
		break;

   //----------------------------------------------------------------------------
   //      DEFAULT
   //----------------------------------------------------------------------------
	default;

		$order = getGetVar('order');
		$direction = getGetVar('direction');
		$letter = getGetVar('letter');
		$accpage = getGetVar('accpage');

		show_default("");
		break;
}

show_footer_page();
?>